(********************************************************************
 * COPYRIGHT -- Bernecker + Rainer
 ********************************************************************
 * Library: SIKODrvLib
 * File: SIKODrvLib.fun
 * Author: hefnera
 * Created: July 31, 2014
 ********************************************************************
 * Functions and function blocks of library SIKODrvLib
 ********************************************************************)

FUNCTION_BLOCK fbSikoAg2x (*TODO: Add your comment here*) (*$GROUP=User*)
	VAR_INPUT
		modulename : STRING[8];
		nodeId : USINT;
		statusWord : UINT;
		actualValue : DINT;
		digitalInputsStatus : USINT;
		PdOutAg2x : PdOutAg2x_type;
		startWrite : BOOL;
		startRead : BOOL;
		startCopy : BOOL;
		startReadDataObj : BOOL;
		startWriteDataObj : BOOL;
	END_VAR
	VAR_OUTPUT
		controlWord : UINT;
		targetValue : DINT;
		digitalOutputsControl : USINT;
		PdInAg2x : PdInAg2x_type;
		counterRead : USINT;
		counterWrite : USINT;
		counterCopy : USINT;
		busy : BOOL;
		error : BOOL;
		done : BOOL;
		status : UINT;
		errorinfo : UDINT;
		parameterValid : BOOL;
	END_VAR
	VAR_INPUT
		ParameterAg2x : REFERENCE TO ParameterAg2x_type;
	END_VAR
	VAR
		counter_read : USINT;
		counter_write : USINT;
		counter_copy : USINT;
		counter_load : USINT;
		fbEplSDORead : EplSDORead;
		fbEplSDOWrite : EplSDOWrite;
		fbR_TRIG1 : R_TRIG;
		fbR_TRIG2 : R_TRIG;
		fbR_TRIG3 : R_TRIG;
		fbR_TRIG4 : R_TRIG;
		fbR_TRIG5 : R_TRIG;
		osrStartRead : BOOL;
		osrStartWrite : BOOL;
		osrStartCopy : BOOL;
		osrStartReadDataObj : BOOL;
		osrStartWriteDataObj : BOOL;
		wrState : USINT;
		rdState : USINT;
		copyState : USINT;
		rdDataObjState : USINT;
		wrDataObjState : USINT;
		DatObjInfo_0 : DatObjInfo;
		DatObjDelete_0 : DatObjDelete;
		DatObjCreate_0 : DatObjCreate;
		DatObjRead_0 : DatObjRead;
	END_VAR
	VAR CONSTANT
		RD_STATE_WAIT_RTRIG : USINT := 0; (*0*)
		RD_STATE_INIT_EPL_SDO_READ : USINT := 1; (*1*)
		RD_STATE_EXEC_EPL_SDO_READ : USINT := 2; (*2*)
		WR_STATE_WAIT_RTRIG : USINT := 0; (*0*)
		WR_STATE_INIT_EPL_SDO_WRITE : USINT := 1; (*1*)
		WR_STATE_EXEC_EPL_SDO_WRITE : USINT := 2; (*2*)
		DORD_STATE_WAIT_RTRIG : USINT := 0; (*0*)
		DORD_STATE_IDENTIFY_MODULE : USINT := 1; (*1*)
		DORD_STATE_LOAD_DEFAULTS : USINT := 2; (*2*)
		DORD_STATE_CREATE_MODULE : USINT := 3; (*3*)
		DORD_STATE_LOAD_TO_STRUCT : USINT := 4; (*4*)
		DORD_STATE_SET_PARAMETER_VALID : USINT := 5; (*5*)
		DOWR_STATE_WAIT_RTRIG : USINT := 0; (*0*)
		DOWR_STATE_IDENTIFY_MODULE : USINT := 1; (*1*)
		DOWR_STATE_DELETE_MODULE : USINT := 2; (*2*)
		DOWR_STATE_CREATE_MODULE : USINT := 3; (*3*)
		COPY_STATE_WAIT_RTRIG : USINT := 0; (*0*)
		COPY_STATE_COPY_R_TO_W : USINT := 1; (*1*)
	END_VAR
END_FUNCTION_BLOCK
